package jalview.ws2;

import java.io.Serializable;
import java.util.Date;
import static java.lang.String.format;

public final class WSJobID implements Serializable
{
  private static final long serialVersionUID = -4600214977954333787L;
  private String serviceType = "";
  private String serviceImpl = "";
  private String jobID = "";
  private Date creationTime = new Date();
  
  public WSJobID() {}
  
  public WSJobID(String serviceType, String serviceImpl, String jobID) {
    this.serviceType = serviceType;
    this.serviceImpl = serviceImpl;
    this.jobID = jobID;
  }
  
  @Override
  public String toString() {
    return format("%s:%s [%s] Created %s",
        serviceType, serviceImpl, jobID, creationTime);
  }

  public String getServiceType()
  {
    return serviceType;
  }

  public void setServiceType(String serviceType)
  {
    this.serviceType = serviceType;
  }

  public String getServiceImpl()
  {
    return serviceImpl;
  }

  public void setServiceImpl(String serviceImpl)
  {
    this.serviceImpl = serviceImpl;
  }

  public String getJobID()
  {
    return jobID;
  }

  public void setJobID(String jobID)
  {
    this.jobID = jobID;
  }

  public Date getCreationTime()
  {
    return creationTime;
  }

  public void setCreationTime(Date creationTime)
  {
    this.creationTime = creationTime;
  }
  
}
