package jalview.ws2;


public enum WSJobState
{
  INVALID, READY, SUBMITTED, QUEUED, RUNNING, FINISHED, BROKEN, FAILED,
  UNKNOWN, SERVER_ERROR, CANCELLED;

  public boolean isSubmitted()
  {
    switch (this)
    {
    case INVALID:
    case READY:
      return false;
    default:
      return true;
    }
  }

  public boolean isCancelled()
  {
    return this == WSJobState.CANCELLED;
  }

  public boolean isDone()
  {
    switch (this)
    {
    case INVALID:
    case READY:
    case SUBMITTED:
    case QUEUED:
    case RUNNING:
      return false;
    default:
      return true;
    }
  }

  public boolean isRunning()
  {
    switch (this)
    {
    case QUEUED:
    case RUNNING:
      return true;
    default:
      return false;
    }
  }

  public boolean isQueued()
  {
    return this == WSJobState.SUBMITTED;
  }
}